/* Kiran Abhang, 18 May 2017, For Defect Fix give by Prashant Darade- S1342161: An Error is Received for Activity Actuals Report When There is a Large Dataset. */
ALTER PROCEDURE [SP_RPT_ACTUALS_SUMMARY] @IsEmbeddedRpt nvarchar(10),@BUIDList nvarchar(max), @FiscalYearList nvarchar(1000),
			@PlanStartDate_From nvarchar(500),@PlanStartDate_To nvarchar(500),@PlanEndDate_From nvarchar(500),@PlanEndDate_To nvarchar(500),
			@PlanID nvarchar(500), @Level nvarchar(100), @ActivityID nvarchar(500),
			@ISACTUALSREPORT numeric , @FISCAL_YEAR bigint   
AS 

	SET NOCOUNT ON
	DECLARE @PLANCLAUSE nvarchar(max), @ACTIVITYCLAUSE nvarchar(max), @WhereClauseAdded int
	DECLARE @DURATION_TYPE NVARCHAR(10),@errorid1 int,@errorid2 int,@errorid int,@final_query nvarchar(max) 
	
	SET @PLANCLAUSE = ''
	SET @ACTIVITYCLAUSE = ''
	SET @WhereClauseAdded = 0
	
	IF(@IsEmbeddedRpt = 1) BEGIN
		IF(@PlanID <> '' and @Level = '0') BEGIN
			SET @PLANCLAUSE = ' WHERE PLANID = ' + @PlanID
		END
		ELSE IF(@Level <> '' and @ActivityID <> '') BEGIN
			SET @ACTIVITYCLAUSE = ' WHERE L' + @Level + 'ID = ' + @ActivityID
		END 
		SET @WhereClauseAdded = 1
	END
	ELSE BEGIN
		IF(@BUIDList <> '') BEGIN
			SET @PLANCLAUSE = ' WHERE BUSINESSUNITID IN ' + @BUIDList
			SET @WhereClauseAdded = 1
		END	
		IF(@FiscalYearList <> '') BEGIN
			IF(@WhereClauseAdded = 0) BEGIN
				SET @PLANCLAUSE = ' WHERE FISCALYEAR IN ' + @FiscalYearList
				SET @WhereClauseAdded = 1
			END
			ELSE BEGIN
				SET @PLANCLAUSE =  @PLANCLAUSE + ' AND (FISCALYEAR IN  ' + @FiscalYearList + ' ) '
			END
		END
		IF (@PlanStartDate_From <> '' or @PlanStartDate_To <> '') BEGIN
			IF(@WhereClauseAdded = 1) BEGIN
				IF (@PlanStartDate_From <> '' and @PlanStartDate_To <> '') BEGIN
					SET @PLANCLAUSE  = @PLANCLAUSE + N' AND FROMDATE BETWEEN '+ '''' + @PlanStartDate_From + '''' + ' AND '+ '''' + @PlanStartDate_To + '''';
				END		
				ELSE IF (@PlanStartDate_From <> '' and @PlanStartDate_To = '')BEGIN
					SET @PLANCLAUSE  = @PLANCLAUSE + N' AND FROMDATE  >= ' + '''' + @PlanStartDate_From + '''';
				END
				ELSE IF (@PlanStartDate_From = '' and @PlanStartDate_To <> '')BEGIN
					SET @PLANCLAUSE  = @PLANCLAUSE + N' AND FROMDATE <= ' + '''' + @PlanStartDate_To + '''';
				END		
			END
			ELSE BEGIN
				IF (@PlanStartDate_From <> '' and @PlanStartDate_To <> '') BEGIN
					SET @PLANCLAUSE  =  N' WHERE FROMDATE BETWEEN '+ '''' + @PlanStartDate_From + '''' + ' AND '+ '''' + @PlanStartDate_To + '''';
				END		
				ELSE IF (@PlanStartDate_From <> '' and @PlanStartDate_To = '')BEGIN
					SET @PLANCLAUSE  =  N' WHERE FROMDATE  >= ' + '''' + @PlanStartDate_From + '''';
				END
				ELSE IF (@PlanStartDate_From = '' and @PlanStartDate_To <> '')BEGIN
					SET @PLANCLAUSE  =  N' WHERE FROMDATE <= ' + '''' + @PlanStartDate_To + '''';
				END		
				SET @WhereClauseAdded = 1
			END		
		END	
		IF (@PlanEndDate_From <> '' or @PlanEndDate_To <> '') BEGIN
			IF(@WhereClauseAdded = 1) BEGIN
				IF (@PlanEndDate_From <> '' and @PlanEndDate_To <> '') BEGIN
					SET @PLANCLAUSE  = @PLANCLAUSE + N' AND TODATE BETWEEN '+ '''' + @PlanEndDate_From + '''' + ' AND '+ '''' + @PlanEndDate_To + '''';
				END		
				ELSE IF (@PlanEndDate_From <> '' and @PlanEndDate_To = '')BEGIN
					SET @PLANCLAUSE  = @PLANCLAUSE + N' AND TODATE  >= ' + '''' + @PlanEndDate_From + '''';
				END
				ELSE IF (@PlanEndDate_From = '' and @PlanEndDate_To <> '')BEGIN
					SET @PLANCLAUSE  = @PLANCLAUSE + N' AND TODATE <= ' + '''' + @PlanEndDate_To + '''';
				END		
			END
			ELSE BEGIN
				IF (@PlanEndDate_From <> '' and @PlanEndDate_To <> '') BEGIN
					SET @PLANCLAUSE  =  N' WHERE TODATE BETWEEN '+ '''' + @PlanEndDate_From + '''' + ' AND '+ '''' + @PlanEndDate_To + '''';
				END		
				ELSE IF (@PlanEndDate_From <> '' and @PlanEndDate_To = '')BEGIN
					SET @PLANCLAUSE  =  N' WHERE TODATE  >= ' + '''' + @PlanEndDate_From + '''';
				END
				ELSE IF (@PlanEndDate_From = '' and @PlanEndDate_To <> '')BEGIN
					SET @PLANCLAUSE  =  N' WHERE TODATE <= ' + '''' + @PlanEndDate_To + '''';
				END	
				SET @WhereClauseAdded = 1	
			END		
		END
	END
	
	EXEC @errorid1 = Verify_Input_Where_Clause @PLANCLAUSE
	EXEC @errorid2 = Verify_Input_Where_Clause @ACTIVITYCLAUSE

	SET @errorid = @errorid1+@errorid2

IF (@errorid=0)
BEGIN
		
		SELECT @DURATION_TYPE = ''
		
		IF EXISTS (SELECT 1 FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = @FISCAL_YEAR)
		BEGIN
			SELECT @DURATION_TYPE = DURATIONTYPE FROM ALENT_FORECASTCONFIGURATION WHERE FISCALYEAR = @FISCAL_YEAR
		END
		ELSE
		BEGIN
			SELECT @DURATION_TYPE = 'CALENDAR'
		END
		
		IF @DURATION_TYPE = 'CALENDAR'
		BEGIN		
			DECLARE @V NVARCHAR(MAX)

			SELECT @V = N' SELECT DISTINCT PLANID, TITLE, STATUS, BUSINESSUNITID, BUNAME, PLAN_COMMITTED_RU, PLAN_ATS_RU, PLAN_AVAILABLE_RU,
			CAST(0.0 AS FLOAT) AS PLAN_M1AMT,CAST(0.0 AS FLOAT) AS PLAN_M2AMT,CAST(0.0 AS FLOAT) AS PLAN_M3AMT,CAST(0.0 AS FLOAT) AS PLAN_M4AMT, CAST(0.0 AS FLOAT) AS PLAN_M5AMT,CAST(0.0 AS FLOAT) AS PLAN_M6AMT,CAST(0.0 AS FLOAT) AS PLAN_M7AMT,CAST(0.0 AS FLOAT) AS PLAN_M8AMT, CAST(0.0 AS FLOAT) AS PLAN_M9AMT,CAST(0.0 AS FLOAT) AS PLAN_M10AMT,CAST(0.0 AS FLOAT) AS PLAN_M11AMT,CAST(0.0 AS FLOAT) AS PLAN_M12AMT, CAST(0.0 AS FLOAT) AS PLAN_Q1AMT,CAST(0.0 AS FLOAT) AS PLAN_Q2AMT,CAST(0.0 AS FLOAT) AS PLAN_Q3AMT,CAST(0.0 AS FLOAT) AS PLAN_Q4AMT,
			L1ID, L1NAME, L1STATUS, L1NUMBER, L1_COMMITTED_RU, L1_ATS_RU, L1_AVAILABLE_RU, L1PATH,
			CAST(0.0 AS FLOAT) AS L1_M1AMT,CAST(0.0 AS FLOAT) AS L1_M2AMT,CAST(0.0 AS FLOAT) AS L1_M3AMT,CAST(0.0 AS FLOAT) AS L1_M4AMT, 
			CAST(0.0 AS FLOAT) AS L1_M5AMT,CAST(0.0 AS FLOAT) AS L1_M6AMT,CAST(0.0 AS FLOAT) AS L1_M7AMT,CAST(0.0 AS FLOAT) AS L1_M8AMT, 
			CAST(0.0 AS FLOAT) AS L1_M9AMT,CAST(0.0 AS FLOAT) AS L1_M10AMT,CAST(0.0 AS FLOAT) AS L1_M11AMT,CAST(0.0 AS FLOAT) AS L1_M12AMT, 
			CAST(0.0 AS FLOAT) AS L1_Q1AMT,CAST(0.0 AS FLOAT) AS L1_Q2AMT,CAST(0.0 AS FLOAT) AS L1_Q3AMT,CAST(0.0 AS FLOAT) AS L1_Q4AMT,
			L2ID, L2NAME, L2STATUS, L2NUMBER, L2_COMMITTED_RU, L2_ATS_RU, L2_AVAILABLE_RU, L2PATH,
			CAST(0.0 AS FLOAT) AS L2_M1AMT,CAST(0.0 AS FLOAT) AS L2_M2AMT,CAST(0.0 AS FLOAT) AS L2_M3AMT,CAST(0.0 AS FLOAT) AS L2_M4AMT, 
			CAST(0.0 AS FLOAT) AS L2_M5AMT,CAST(0.0 AS FLOAT) AS L2_M6AMT,CAST(0.0 AS FLOAT) AS L2_M7AMT,CAST(0.0 AS FLOAT) AS L2_M8AMT, 
			CAST(0.0 AS FLOAT) AS L2_M9AMT,CAST(0.0 AS FLOAT) AS L2_M10AMT,CAST(0.0 AS FLOAT) AS L2_M11AMT,CAST(0.0 AS FLOAT) AS L2_M12AMT, 
			CAST(0.0 AS FLOAT) AS L2_Q1AMT,CAST(0.0 AS FLOAT) AS L2_Q2AMT,CAST(0.0 AS FLOAT) AS L2_Q3AMT,CAST(0.0 AS FLOAT) AS L2_Q4AMT,
			L3ID, L3NAME, L3STATUS, L3NUMBER, L3_COMMITTED_RU, L3_ATS_RU, L3_AVAILABLE_RU, L3PATH,
			CAST(0.0 AS FLOAT) AS L3_M1AMT,CAST(0.0 AS FLOAT) AS L3_M2AMT,CAST(0.0 AS FLOAT) AS L3_M3AMT,CAST(0.0 AS FLOAT) AS L3_M4AMT, 
			CAST(0.0 AS FLOAT) AS L3_M5AMT,CAST(0.0 AS FLOAT) AS L3_M6AMT,CAST(0.0 AS FLOAT) AS L3_M7AMT,CAST(0.0 AS FLOAT) AS L3_M8AMT, 
			CAST(0.0 AS FLOAT) AS L3_M9AMT,CAST(0.0 AS FLOAT) AS L3_M10AMT,CAST(0.0 AS FLOAT) AS L3_M11AMT,CAST(0.0 AS FLOAT) AS L3_M12AMT, 
			CAST(0.0 AS FLOAT) AS L3_Q1AMT,CAST(0.0 AS FLOAT) AS L3_Q2AMT,CAST(0.0 AS FLOAT) AS L3_Q3AMT,CAST(0.0 AS FLOAT) AS L3_Q4AMT,
			L4ID, L4NAME, L4STATUS, L4NUMBER, L4_COMMITTED_RU, L4_ATS_RU, L4_AVAILABLE_RU, L4PATH,
			CAST(0.0 AS FLOAT) AS L4_M1AMT,CAST(0.0 AS FLOAT) AS L4_M2AMT,CAST(0.0 AS FLOAT) AS L4_M3AMT,CAST(0.0 AS FLOAT) AS L4_M4AMT, 
			CAST(0.0 AS FLOAT) AS L4_M5AMT,CAST(0.0 AS FLOAT) AS L4_M6AMT,CAST(0.0 AS FLOAT) AS L4_M7AMT,CAST(0.0 AS FLOAT) AS L4_M8AMT, 
			CAST(0.0 AS FLOAT) AS L4_M9AMT,CAST(0.0 AS FLOAT) AS L4_M10AMT,CAST(0.0 AS FLOAT) AS L4_M11AMT,CAST(0.0 AS FLOAT) AS L4_M12AMT, 
			CAST(0.0 AS FLOAT) AS L4_Q1AMT,CAST(0.0 AS FLOAT) AS L4_Q2AMT,CAST(0.0 AS FLOAT) AS L4_Q3AMT,CAST(0.0 AS FLOAT) AS L4_Q4AMT,
			L5ID, L5NAME, L5STATUS, L5NUMBER, L5_COMMITTED_RU, L5_ATS_RU, L5_AVAILABLE_RU, L5PATH,
			CAST(0.0 AS FLOAT) AS L5_M1AMT,CAST(0.0 AS FLOAT) AS L5_M2AMT,CAST(0.0 AS FLOAT) AS L5_M3AMT,CAST(0.0 AS FLOAT) AS L5_M4AMT, 
			CAST(0.0 AS FLOAT) AS L5_M5AMT,CAST(0.0 AS FLOAT) AS L5_M6AMT,CAST(0.0 AS FLOAT) AS L5_M7AMT,CAST(0.0 AS FLOAT) AS L5_M8AMT, 
			CAST(0.0 AS FLOAT) AS L5_M9AMT,CAST(0.0 AS FLOAT) AS L5_M10AMT,CAST(0.0 AS FLOAT) AS L5_M11AMT,CAST(0.0 AS FLOAT) AS L5_M12AMT, 
			CAST(0.0 AS FLOAT) AS L5_Q1AMT,CAST(0.0 AS FLOAT) AS L5_Q2AMT,CAST(0.0 AS FLOAT) AS L5_Q3AMT,CAST(0.0 AS FLOAT) AS L5_Q4AMT, 
			GETDATE() AS UPDATEDON
			INTO #CAL_TEMP_RPT_ACTIVITY_REPORTS
			FROM RPT_ACTIVITY_REPORTS  '+ @PLANCLAUSE + @ACTIVITYCLAUSE   
			
				
			DECLARE @V1 NVARCHAR(MAX)
			SELECT @V1 =   N'  UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET PLAN_M1AMT = M1AMT,PLAN_M2AMT = M2AMT,PLAN_M3AMT = M3AMT,PLAN_M4AMT = M4AMT,PLAN_M5AMT = M5AMT,PLAN_M6AMT = M6AMT,
							PLAN_M7AMT = M7AMT,PLAN_M8AMT = M8AMT,PLAN_M9AMT = M9AMT,PLAN_M10AMT = M10AMT,PLAN_M11AMT = M11AMT,PLAN_M12AMT = M12AMT,
							PLAN_Q1AMT = Q1AMT,PLAN_Q2AMT = Q2AMT,PLAN_Q3AMT = Q3AMT,PLAN_Q4AMT = Q4AMT
							FROM #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON PLANID = ENTITYID  
							
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET L1_M1AMT = M1AMT,L1_M2AMT = M2AMT,L1_M3AMT = M3AMT,L1_M4AMT = M4AMT,L1_M5AMT = M5AMT,L1_M6AMT = M6AMT,L1_M7AMT = M7AMT,
							L1_M8AMT = M8AMT,L1_M9AMT = M9AMT,L1_M10AMT = M10AMT,L1_M11AMT = M11AMT,L1_M12AMT = M12AMT,
							L1_Q1AMT = Q1AMT,L1_Q2AMT = Q2AMT,L1_Q3AMT = Q3AMT,L1_Q4AMT = Q4AMT
							FROM  #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L1ID = ENTITYID
							
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET L2_M1AMT = M1AMT,L2_M2AMT = M2AMT,L2_M3AMT = M3AMT,L2_M4AMT = M4AMT,L2_M5AMT = M5AMT,L2_M6AMT = M6AMT,L2_M7AMT = M7AMT,
							L2_M8AMT = M8AMT,L2_M9AMT = M9AMT,L2_M10AMT = M10AMT,L2_M11AMT = M11AMT,L2_M12AMT = M12AMT,
							L2_Q1AMT = Q1AMT,L2_Q2AMT = Q2AMT,L2_Q3AMT = Q3AMT,L2_Q4AMT = Q4AMT
							FROM #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L2ID = ENTITYID
							
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET L3_M1AMT = M1AMT,L3_M2AMT = M2AMT,L3_M3AMT = M3AMT,L3_M4AMT = M4AMT,L3_M5AMT = M5AMT,L3_M6AMT = M6AMT,L3_M7AMT = M7AMT,
							L3_M8AMT = M8AMT,L3_M9AMT = M9AMT,L3_M10AMT = M10AMT,L3_M11AMT = M11AMT,L3_M12AMT = M12AMT,
							L3_Q1AMT = Q1AMT,L3_Q2AMT = Q2AMT,L3_Q3AMT = Q3AMT,L3_Q4AMT = Q4AMT
							FROM  #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L3ID = ENTITYID
							
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET L4_M1AMT = M1AMT,L4_M2AMT = M2AMT,L4_M3AMT = M3AMT,L4_M4AMT = M4AMT,L4_M5AMT = M5AMT,L4_M6AMT = M6AMT,L4_M7AMT = M7AMT,
							L4_M8AMT = M8AMT,L4_M9AMT = M9AMT,L4_M10AMT = M10AMT,L4_M11AMT = M11AMT,L4_M12AMT = M12AMT,
							L4_Q1AMT = Q1AMT,L4_Q2AMT = Q2AMT,L4_Q3AMT = Q3AMT,L4_Q4AMT = Q4AMT
							FROM  #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L4ID = ENTITYID
							
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET L5_M1AMT = M1AMT,L5_M2AMT = M2AMT,L5_M3AMT = M3AMT,L5_M4AMT = M4AMT,L5_M5AMT = M5AMT,L5_M6AMT = M6AMT,L5_M7AMT = M7AMT,
							L5_M8AMT = M8AMT,L5_M9AMT = M9AMT,L5_M10AMT = M10AMT,L5_M11AMT = M11AMT,L5_M12AMT = M12AMT,
							L5_Q1AMT = Q1AMT,L5_Q2AMT = Q2AMT,L5_Q3AMT = Q3AMT,L5_Q4AMT = Q4AMT
							FROM  #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L5ID = ENTITYID  
								
							SELECT DISTINCT 
							PLANID, TITLE, STATUS, BUSINESSUNITID, BUNAME, PLAN_COMMITTED_RU, PLAN_ATS_RU, PLAN_AVAILABLE_RU, 
							PLAN_M1AMT, PLAN_M2AMT, PLAN_M3AMT, PLAN_M4AMT, PLAN_M5AMT, PLAN_M6AMT, PLAN_M7AMT, PLAN_M8AMT, PLAN_M9AMT, PLAN_M10AMT, PLAN_M11AMT,PLAN_M12AMT, PLAN_Q1AMT, PLAN_Q2AMT, PLAN_Q3AMT, PLAN_Q4AMT,
							L1ID, L1NAME, L1STATUS, L1NUMBER, L1_COMMITTED_RU, L1_ATS_RU, L1_AVAILABLE_RU, L1PATH,
							L1_M1AMT, L1_M2AMT, L1_M3AMT, L1_M4AMT, L1_M5AMT, L1_M6AMT, L1_M7AMT, L1_M8AMT, L1_M9AMT, L1_M10AMT, L1_M11AMT, L1_M12AMT, 
							L1_Q1AMT, L1_Q2AMT, L1_Q3AMT, L1_Q4AMT,
							L2ID, L2NAME, L2STATUS, L2NUMBER, L2_COMMITTED_RU, L2_ATS_RU, L2_AVAILABLE_RU, L2PATH,
							L2_M1AMT, L2_M2AMT, L2_M3AMT, L2_M4AMT, L2_M5AMT, L2_M6AMT, L2_M7AMT, L2_M8AMT, L2_M9AMT, L2_M10AMT, L2_M11AMT, L2_M12AMT, 
							L2_Q1AMT, L2_Q2AMT, L2_Q3AMT, L2_Q4AMT,
							L3ID, L3NAME, L3STATUS, L3NUMBER, L3_COMMITTED_RU, L3_ATS_RU, L3_AVAILABLE_RU, L3PATH,
							L3_M1AMT, L3_M2AMT, L3_M3AMT, L3_M4AMT, L3_M5AMT, L3_M6AMT, L3_M7AMT, L3_M8AMT, L3_M9AMT, L3_M10AMT, L3_M11AMT, L3_M12AMT, 
							L3_Q1AMT, L3_Q2AMT, L3_Q3AMT, L3_Q4AMT,
							L4ID, L4NAME, L4STATUS, L4NUMBER, L4_COMMITTED_RU, L4_ATS_RU, L4_AVAILABLE_RU, L4PATH,
							L4_M1AMT, L4_M2AMT, L4_M3AMT, L4_M4AMT, L4_M5AMT, L4_M6AMT, L4_M7AMT, L4_M8AMT, L4_M9AMT, L4_M10AMT, L4_M11AMT, L4_M12AMT, 
							L4_Q1AMT, L4_Q2AMT,L4_Q3AMT, L4_Q4AMT,
							L5ID, L5NAME, L5STATUS, L5NUMBER, L5_COMMITTED_RU, L5_ATS_RU, L5_AVAILABLE_RU, L5PATH,
							L5_M1AMT, L5_M2AMT, L5_M3AMT, L5_M4AMT, L5_M5AMT, L5_M6AMT, L5_M7AMT, L5_M8AMT, L5_M9AMT, L5_M10AMT, L5_M11AMT, L5_M12AMT, 
							L5_Q1AMT, L5_Q2AMT, L5_Q3AMT, L5_Q4AMT, GETDATE() AS UPDATEDON
							FROM  #CAL_TEMP_RPT_ACTIVITY_REPORTS   '

	

			DECLARE @V1_1 NVARCHAR(4000)
			SELECT @V1_1 =   N'  UNION  SELECT TOP 1 NULL AS PLANID, NULL AS TITLE, NULL AS STATUS, NULL AS BUSINESSUNITID, NULL AS BUNAME, NULL AS PLAN_COMMITTED_RU, NULL AS PLAN_ATS_RU, NULL AS PLAN_AVAILABLE_RU, 
			NULL AS PLAN_M1AMT, NULL AS PLAN_M2AMT, NULL AS PLAN_M3AMT, NULL AS PLAN_M4AMT, NULL AS PLAN_M5AMT, NULL AS PLAN_M6AMT, NULL AS PLAN_M7AMT, NULL AS PLAN_M8AMT, NULL AS PLAN_M9AMT, NULL AS PLAN_M10AMT, NULL AS PLAN_M11AMT, NULL AS PLAN_M12AMT, NULL AS PLAN_Q1AMT, NULL AS PLAN_Q2AMT, NULL AS PLAN_Q3AMT, NULL AS PLAN_Q4AMT,
			NULL AS L1ID, NULL AS L1NAME, NULL AS L1STATUS, NULL AS L1NUMBER, NULL AS L1_COMMITTED_RU, NULL AS L1_ATS_RU, NULL AS L1_AVAILABLE_RU, NULL AS L1PATH,
			NULL AS L1_M1AMT, NULL AS L1_M2AMT, NULL AS L1_M3AMT, NULL AS L1_M4AMT, NULL AS L1_M5AMT, NULL AS L1_M6AMT, NULL AS L1_M7AMT, NULL AS L1_M8AMT, NULL AS L1_M9AMT, NULL AS L1_M10AMT, NULL AS L1_M11AMT, NULL AS L1_M12AMT, NULL AS L1_Q1AMT, NULL AS L1_Q2AMT, NULL AS L1_Q3AMT, NULL AS L1_Q4AMT,
			NULL AS L2ID, NULL AS L2NAME, NULL AS L2STATUS, NULL AS L2NUMBER, NULL AS L2_COMMITTED_RU, NULL AS L2_ATS_RU, NULL AS L2_AVAILABLE_RU, NULL AS L2PATH,
			NULL AS L2_M1AMT, NULL AS L2_M2AMT, NULL AS L2_M3AMT, NULL AS L2_M4AMT, NULL AS L2_M5AMT, NULL AS L2_M6AMT, NULL AS L2_M7AMT, NULL AS L2_M8AMT, NULL AS L2_M9AMT, NULL AS L2_M10AMT, NULL AS L2_M11AMT, NULL AS L2_M12AMT, NULL AS L2_Q1AMT, NULL AS L2_Q2AMT, NULL AS L2_Q3AMT, NULL AS L2_Q4AMT,
			NULL AS L3ID, NULL AS L3NAME, NULL AS L3STATUS, NULL AS L3NUMBER, NULL AS L3_COMMITTED_RU, NULL AS L3_ATS_RU, NULL AS L3_AVAILABLE_RU, NULL AS L3PATH,
			NULL AS L3_M1AMT, NULL AS L3_M2AMT, NULL AS L3_M3AMT, NULL AS L3_M4AMT, NULL AS L3_M5AMT, NULL AS L3_M6AMT, NULL AS L3_M7AMT, NULL AS L3_M8AMT, NULL AS L3_M9AMT, NULL AS L3_M10AMT, NULL AS L3_M11AMT, NULL AS L3_M12AMT, NULL AS L3_Q1AMT, NULL AS L3_Q2AMT, NULL AS L3_Q3AMT, NULL AS L3_Q4AMT,
			NULL AS L4ID, NULL AS L4NAME, NULL AS L4STATUS, NULL AS L4NUMBER, NULL AS L4_COMMITTED_RU, NULL AS L4_ATS_RU, NULL AS L4_AVAILABLE_RU, NULL AS L4PATH,
			NULL AS L4_M1AMT, NULL AS L4_M2AMT, NULL AS L4_M3AMT, NULL AS L4_M4AMT, NULL AS L4_M5AMT, NULL AS L4_M6AMT, NULL AS L4_M7AMT, NULL AS L4_M8AMT, NULL AS L4_M9AMT, NULL AS L4_M10AMT, NULL AS L4_M11AMT, NULL AS L4_M12AMT, NULL AS L4_Q1AMT, NULL AS L4_Q2AMT, NULL AS L4_Q3AMT, NULL AS L4_Q4AMT,
			NULL AS L5ID, NULL AS L5NAME, NULL AS L5STATUS, NULL AS L5NUMBER, NULL AS L5_COMMITTED_RU, NULL AS L5_ATS_RU, NULL AS L5_AVAILABLE_RU, NULL AS L5PATH,
			NULL AS L5_M1AMT, NULL AS L5_M2AMT, NULL AS L5_M3AMT, NULL AS L5_M4AMT, NULL AS L5_M5AMT, NULL AS L5_M6AMT, NULL AS L5_M7AMT, NULL AS L5_M8AMT, NULL AS L5_M9AMT, NULL AS L5_M10AMT, NULL AS L5_M11AMT, NULL AS L5_M12AMT, NULL AS L5_Q1AMT, NULL AS L5_Q2AMT, NULL AS L5_Q3AMT, NULL AS L5_Q4AMT, UPDATEDON
			FROM  RPT_ACTIVITY_REPORTS  '

			DECLARE @UNION1 NVARCHAR(4000)
			SELECT @UNION1 =   N' ORDER BY BUNAME, TITLE, L1NAME, L2NAME, L3NAME, L4NAME, L5NAME ASC  '

			DECLARE @V2 NVARCHAR(MAX)
			SELECT @V2 =   N'  
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET PLAN_M1AMT = M1AMT,PLAN_M2AMT = M2AMT,PLAN_M3AMT = M3AMT,PLAN_M4AMT = M4AMT,PLAN_M5AMT = M5AMT,PLAN_M6AMT = M6AMT,
							PLAN_M7AMT = M7AMT,PLAN_M8AMT = M8AMT,PLAN_M9AMT = M9AMT,PLAN_M10AMT = M10AMT,PLAN_M11AMT = M11AMT,PLAN_M12AMT = M12AMT,
							PLAN_Q1AMT = Q1AMT,PLAN_Q2AMT = Q2AMT,PLAN_Q3AMT = Q3AMT,PLAN_Q4AMT = Q4AMT
							FROM #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON PLANID = ENTITYID  
							
							UPDATE #CAL_TEMP_RPT_ACTIVITY_REPORTS
							SET L1_M1AMT = M1AMT,L1_M2AMT = M2AMT,L1_M3AMT = M3AMT,L1_M4AMT = M4AMT,L1_M5AMT = M5AMT,L1_M6AMT = M6AMT,L1_M7AMT = M7AMT,
							L1_M8AMT = M8AMT,L1_M9AMT = M9AMT,L1_M10AMT = M10AMT,L1_M11AMT = M11AMT,L1_M12AMT = M12AMT,
							L1_Q1AMT = Q1AMT,L1_Q2AMT = Q2AMT,L1_Q3AMT = Q3AMT,L1_Q4AMT = Q4AMT
							FROM  #CAL_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L1ID = ENTITYID
							
							SELECT DISTINCT 
							PLANID, TITLE, STATUS, BUSINESSUNITID, BUNAME, PLAN_COMMITTED_RU, PLAN_ATS_RU, PLAN_AVAILABLE_RU, 
							PLAN_M1AMT, PLAN_M2AMT, PLAN_M3AMT, PLAN_M4AMT, PLAN_M5AMT, PLAN_M6AMT, PLAN_M7AMT, PLAN_M8AMT, PLAN_M9AMT, PLAN_M10AMT, PLAN_M11AMT,PLAN_M12AMT, 
							PLAN_Q1AMT, PLAN_Q2AMT, PLAN_Q3AMT, PLAN_Q4AMT,
							L1ID, L1NAME, L1STATUS, L1_COMMITTED_RU, L1_ATS_RU, L1_AVAILABLE_RU, L1PATH,
							L1_M1AMT, L1_M2AMT, L1_M3AMT, L1_M4AMT, L1_M5AMT, L1_M6AMT, L1_M7AMT, L1_M8AMT, L1_M9AMT, L1_M10AMT, L1_M11AMT, L1_M12AMT, 
							L1_Q1AMT, L1_Q2AMT, L1_Q3AMT, L1_Q4AMT, GETDATE() AS UPDATEDON
							FROM #CAL_TEMP_RPT_ACTIVITY_REPORTS   '
			
			
			DECLARE @V2_2 NVARCHAR(4000)
			SELECT @V2_2 =   N' UNION  SELECT TOP 1  NULL AS PLANID, NULL AS TITLE, NULL AS STATUS, NULL AS BUSINESSUNITID, NULL AS BUNAME, NULL AS PLAN_COMMITTED_RU, NULL AS PLAN_ATS_RU, NULL AS PLAN_AVAILABLE_RU, 
			NULL AS PLAN_M1AMT, NULL AS PLAN_M2AMT, NULL AS PLAN_M3AMT, NULL AS PLAN_M4AMT, NULL AS PLAN_M5AMT, NULL AS PLAN_M6AMT, NULL AS PLAN_M7AMT, NULL AS PLAN_M8AMT, NULL AS PLAN_M9AMT, NULL AS PLAN_M10AMT, NULL AS PLAN_M11AMT, NULL AS PLAN_M12AMT, NULL AS PLAN_Q1AMT, NULL AS PLAN_Q2AMT, NULL AS PLAN_Q3AMT, NULL AS PLAN_Q4AMT,
			NULL AS L1ID, NULL AS L1NAME, NULL AS L1STATUS, NULL AS L1_COMMITTED_RU, NULL AS L1_ATS_RU, NULL AS L1_AVAILABLE_RU, NULL AS L1PATH,
			NULL AS L1_M1AMT, NULL AS L1_M2AMT, NULL AS L1_M3AMT, NULL AS L1_M4AMT, NULL AS L1_M5AMT, NULL AS L1_M6AMT, NULL AS L1_M7AMT, NULL AS L1_M8AMT, NULL AS L1_M9AMT, NULL AS L1_M10AMT, NULL AS L1_M11AMT, NULL AS L1_M12AMT, NULL AS L1_Q1AMT, NULL AS L1_Q2AMT, NULL AS L1_Q3AMT, NULL AS L1_Q4AMT, UPDATEDON
			FROM  RPT_ACTIVITY_REPORTS  '

			DECLARE @UNION2 NVARCHAR(4000)
			SELECT @UNION2 =   N' ORDER BY BUNAME, TITLE, L1NAME ASC '

			IF(@ISACTUALSREPORT = 1)
			BEGIN
			set @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) +@V + @V1 + @V1_1 + @UNION1
			EXEC DBO.SP_EXECUTESQL @final_query
			END
			ELSE IF(@ISACTUALSREPORT = 0)
			BEGIN
			set @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) + @V + @V2 + @V2_2 + @UNION2		
			EXEC DBO.SP_EXECUTESQL @final_query
		END
	END
	ELSE	/*	DURATION_TYPE = PERIODS	*/
	BEGIN
	    	IF @DURATION_TYPE = 'PERIOD'
	   		BEGIN
				DECLARE @V_PER NVARCHAR(MAX)

				SELECT @V_PER = N' SELECT DISTINCT PLANID, TITLE, STATUS, BUSINESSUNITID, BUNAME, PLAN_COMMITTED_RU, PLAN_ATS_RU, PLAN_AVAILABLE_RU,
				CAST(0.0 AS FLOAT) AS PLAN_M1AMT,CAST(0.0 AS FLOAT) AS PLAN_M2AMT,CAST(0.0 AS FLOAT) AS PLAN_M3AMT,CAST(0.0 AS FLOAT) AS PLAN_M4AMT, CAST(0.0 AS FLOAT) AS PLAN_M5AMT,CAST(0.0 AS FLOAT) AS PLAN_M6AMT,CAST(0.0 AS FLOAT) AS PLAN_M7AMT,CAST(0.0 AS FLOAT) AS PLAN_M8AMT, CAST(0.0 AS FLOAT) AS PLAN_M9AMT,CAST(0.0 AS FLOAT) AS PLAN_M10AMT,CAST(0.0 AS FLOAT) AS PLAN_M11AMT,CAST(0.0 AS FLOAT) AS PLAN_M12AMT, CAST(0.0 AS FLOAT) AS PLAN_Q1AMT,CAST(0.0 AS FLOAT) AS PLAN_Q2AMT,CAST(0.0 AS FLOAT) AS PLAN_Q3AMT,CAST(0.0 AS FLOAT) AS PLAN_Q4AMT,
				L1ID, L1NAME, L1STATUS, L1NUMBER, L1_COMMITTED_RU, L1_ATS_RU, L1_AVAILABLE_RU, L1PATH,
				CAST(0.0 AS FLOAT) AS L1_M1AMT,CAST(0.0 AS FLOAT) AS L1_M2AMT,CAST(0.0 AS FLOAT) AS L1_M3AMT,CAST(0.0 AS FLOAT) AS L1_M4AMT, 
				CAST(0.0 AS FLOAT) AS L1_M5AMT,CAST(0.0 AS FLOAT) AS L1_M6AMT,CAST(0.0 AS FLOAT) AS L1_M7AMT,CAST(0.0 AS FLOAT) AS L1_M8AMT, 
				CAST(0.0 AS FLOAT) AS L1_M9AMT,CAST(0.0 AS FLOAT) AS L1_M10AMT,CAST(0.0 AS FLOAT) AS L1_M11AMT,CAST(0.0 AS FLOAT) AS L1_M12AMT, 
				CAST(0.0 AS FLOAT) AS L1_Q1AMT,CAST(0.0 AS FLOAT) AS L1_Q2AMT,CAST(0.0 AS FLOAT) AS L1_Q3AMT,CAST(0.0 AS FLOAT) AS L1_Q4AMT,
				L2ID, L2NAME, L2STATUS, L2NUMBER, L2_COMMITTED_RU, L2_ATS_RU, L2_AVAILABLE_RU, L2PATH,
				CAST(0.0 AS FLOAT) AS L2_M1AMT,CAST(0.0 AS FLOAT) AS L2_M2AMT,CAST(0.0 AS FLOAT) AS L2_M3AMT,CAST(0.0 AS FLOAT) AS L2_M4AMT, 
				CAST(0.0 AS FLOAT) AS L2_M5AMT,CAST(0.0 AS FLOAT) AS L2_M6AMT,CAST(0.0 AS FLOAT) AS L2_M7AMT,CAST(0.0 AS FLOAT) AS L2_M8AMT, 
				CAST(0.0 AS FLOAT) AS L2_M9AMT,CAST(0.0 AS FLOAT) AS L2_M10AMT,CAST(0.0 AS FLOAT) AS L2_M11AMT,CAST(0.0 AS FLOAT) AS L2_M12AMT, 
				CAST(0.0 AS FLOAT) AS L2_Q1AMT,CAST(0.0 AS FLOAT) AS L2_Q2AMT,CAST(0.0 AS FLOAT) AS L2_Q3AMT,CAST(0.0 AS FLOAT) AS L2_Q4AMT,
				L3ID, L3NAME, L3STATUS, L3NUMBER, L3_COMMITTED_RU, L3_ATS_RU, L3_AVAILABLE_RU, L3PATH,
				CAST(0.0 AS FLOAT) AS L3_M1AMT,CAST(0.0 AS FLOAT) AS L3_M2AMT,CAST(0.0 AS FLOAT) AS L3_M3AMT,CAST(0.0 AS FLOAT) AS L3_M4AMT, 
				CAST(0.0 AS FLOAT) AS L3_M5AMT,CAST(0.0 AS FLOAT) AS L3_M6AMT,CAST(0.0 AS FLOAT) AS L3_M7AMT,CAST(0.0 AS FLOAT) AS L3_M8AMT, 
				CAST(0.0 AS FLOAT) AS L3_M9AMT,CAST(0.0 AS FLOAT) AS L3_M10AMT,CAST(0.0 AS FLOAT) AS L3_M11AMT,CAST(0.0 AS FLOAT) AS L3_M12AMT, 
				CAST(0.0 AS FLOAT) AS L3_Q1AMT,CAST(0.0 AS FLOAT) AS L3_Q2AMT,CAST(0.0 AS FLOAT) AS L3_Q3AMT,CAST(0.0 AS FLOAT) AS L3_Q4AMT,
				L4ID, L4NAME, L4STATUS, L4NUMBER, L4_COMMITTED_RU, L4_ATS_RU, L4_AVAILABLE_RU, L4PATH,
				CAST(0.0 AS FLOAT) AS L4_M1AMT,CAST(0.0 AS FLOAT) AS L4_M2AMT,CAST(0.0 AS FLOAT) AS L4_M3AMT,CAST(0.0 AS FLOAT) AS L4_M4AMT, 
				CAST(0.0 AS FLOAT) AS L4_M5AMT,CAST(0.0 AS FLOAT) AS L4_M6AMT,CAST(0.0 AS FLOAT) AS L4_M7AMT,CAST(0.0 AS FLOAT) AS L4_M8AMT, 
				CAST(0.0 AS FLOAT) AS L4_M9AMT,CAST(0.0 AS FLOAT) AS L4_M10AMT,CAST(0.0 AS FLOAT) AS L4_M11AMT,CAST(0.0 AS FLOAT) AS L4_M12AMT, 
				CAST(0.0 AS FLOAT) AS L4_Q1AMT,CAST(0.0 AS FLOAT) AS L4_Q2AMT,CAST(0.0 AS FLOAT) AS L4_Q3AMT,CAST(0.0 AS FLOAT) AS L4_Q4AMT,
				L5ID, L5NAME, L5STATUS, L5NUMBER, L5_COMMITTED_RU, L5_ATS_RU, L5_AVAILABLE_RU, L5PATH,
				CAST(0.0 AS FLOAT) AS L5_M1AMT,CAST(0.0 AS FLOAT) AS L5_M2AMT,CAST(0.0 AS FLOAT) AS L5_M3AMT,CAST(0.0 AS FLOAT) AS L5_M4AMT, 
				CAST(0.0 AS FLOAT) AS L5_M5AMT,CAST(0.0 AS FLOAT) AS L5_M6AMT,CAST(0.0 AS FLOAT) AS L5_M7AMT,CAST(0.0 AS FLOAT) AS L5_M8AMT, 
				CAST(0.0 AS FLOAT) AS L5_M9AMT,CAST(0.0 AS FLOAT) AS L5_M10AMT,CAST(0.0 AS FLOAT) AS L5_M11AMT,CAST(0.0 AS FLOAT) AS L5_M12AMT, 
				CAST(0.0 AS FLOAT) AS L5_Q1AMT,CAST(0.0 AS FLOAT) AS L5_Q2AMT,CAST(0.0 AS FLOAT) AS L5_Q3AMT,CAST(0.0 AS FLOAT) AS L5_Q4AMT, 
				GETDATE() AS UPDATEDON
				INTO #PRD_TEMP_RPT_ACTIVITY_REPORTS
				FROM RPT_ACTIVITY_REPORTS  '+ @PLANCLAUSE + @ACTIVITYCLAUSE    

				DECLARE @V1_PER NVARCHAR(MAX)
				SELECT @V1_PER =   N'  UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET PLAN_M1AMT = M1AMT,PLAN_M2AMT = M2AMT,PLAN_M3AMT = M3AMT,PLAN_M4AMT = M4AMT,PLAN_M5AMT = M5AMT,PLAN_M6AMT = M6AMT,
							PLAN_M7AMT = M7AMT,PLAN_M8AMT = M8AMT,PLAN_M9AMT = M9AMT,PLAN_M10AMT = M10AMT,PLAN_M11AMT = M11AMT,PLAN_M12AMT = M12AMT,
							PLAN_Q1AMT = Q1AMT,PLAN_Q2AMT = Q2AMT,PLAN_Q3AMT = Q3AMT,PLAN_Q4AMT = Q4AMT
							FROM #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON PLANID = ENTITYID  
							
							UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET L1_M1AMT = M1AMT,L1_M2AMT = M2AMT,L1_M3AMT = M3AMT,L1_M4AMT = M4AMT,L1_M5AMT = M5AMT,L1_M6AMT = M6AMT,L1_M7AMT = M7AMT,
							L1_M8AMT = M8AMT,L1_M9AMT = M9AMT,L1_M10AMT = M10AMT,L1_M11AMT = M11AMT,L1_M12AMT = M12AMT,
							L1_Q1AMT = Q1AMT,L1_Q2AMT = Q2AMT,L1_Q3AMT = Q3AMT,L1_Q4AMT = Q4AMT
							FROM  #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L1ID = ENTITYID
							
							UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET L2_M1AMT = M1AMT,L2_M2AMT = M2AMT,L2_M3AMT = M3AMT,L2_M4AMT = M4AMT,L2_M5AMT = M5AMT,L2_M6AMT = M6AMT,L2_M7AMT = M7AMT,
							L2_M8AMT = M8AMT,L2_M9AMT = M9AMT,L2_M10AMT = M10AMT,L2_M11AMT = M11AMT,L2_M12AMT = M12AMT,
							L2_Q1AMT = Q1AMT,L2_Q2AMT = Q2AMT,L2_Q3AMT = Q3AMT,L2_Q4AMT = Q4AMT
							FROM #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L2ID = ENTITYID
							
							UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET L3_M1AMT = M1AMT,L3_M2AMT = M2AMT,L3_M3AMT = M3AMT,L3_M4AMT = M4AMT,L3_M5AMT = M5AMT,L3_M6AMT = M6AMT,L3_M7AMT = M7AMT,
							L3_M8AMT = M8AMT,L3_M9AMT = M9AMT,L3_M10AMT = M10AMT,L3_M11AMT = M11AMT,L3_M12AMT = M12AMT,
							L3_Q1AMT = Q1AMT,L3_Q2AMT = Q2AMT,L3_Q3AMT = Q3AMT,L3_Q4AMT = Q4AMT
							FROM  #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L3ID = ENTITYID
							
							UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET L4_M1AMT = M1AMT,L4_M2AMT = M2AMT,L4_M3AMT = M3AMT,L4_M4AMT = M4AMT,L4_M5AMT = M5AMT,L4_M6AMT = M6AMT,L4_M7AMT = M7AMT,
							L4_M8AMT = M8AMT,L4_M9AMT = M9AMT,L4_M10AMT = M10AMT,L4_M11AMT = M11AMT,L4_M12AMT = M12AMT,
							L4_Q1AMT = Q1AMT,L4_Q2AMT = Q2AMT,L4_Q3AMT = Q3AMT,L4_Q4AMT = Q4AMT
							FROM  #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L4ID = ENTITYID
							
							UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET L5_M1AMT = M1AMT,L5_M2AMT = M2AMT,L5_M3AMT = M3AMT,L5_M4AMT = M4AMT,L5_M5AMT = M5AMT,L5_M6AMT = M6AMT,L5_M7AMT = M7AMT,
							L5_M8AMT = M8AMT,L5_M9AMT = M9AMT,L5_M10AMT = M10AMT,L5_M11AMT = M11AMT,L5_M12AMT = M12AMT,
							L5_Q1AMT = Q1AMT,L5_Q2AMT = Q2AMT,L5_Q3AMT = Q3AMT,L5_Q4AMT = Q4AMT
							FROM  #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L5ID = ENTITYID  
								
							SELECT DISTINCT 
							PLANID, TITLE, STATUS, BUSINESSUNITID, BUNAME, PLAN_COMMITTED_RU, PLAN_ATS_RU, PLAN_AVAILABLE_RU, 
							PLAN_M1AMT, PLAN_M2AMT, PLAN_M3AMT, PLAN_M4AMT, PLAN_M5AMT, PLAN_M6AMT, PLAN_M7AMT, PLAN_M8AMT, PLAN_M9AMT, PLAN_M10AMT, PLAN_M11AMT,PLAN_M12AMT, PLAN_Q1AMT, PLAN_Q2AMT, PLAN_Q3AMT, PLAN_Q4AMT,
							L1ID, L1NAME, L1STATUS, L1NUMBER, L1_COMMITTED_RU, L1_ATS_RU, L1_AVAILABLE_RU, L1PATH,
							L1_M1AMT, L1_M2AMT, L1_M3AMT, L1_M4AMT, L1_M5AMT, L1_M6AMT, L1_M7AMT, L1_M8AMT, L1_M9AMT, L1_M10AMT, L1_M11AMT, L1_M12AMT, 
							L1_Q1AMT, L1_Q2AMT, L1_Q3AMT, L1_Q4AMT,
							L2ID, L2NAME, L2STATUS, L2NUMBER, L2_COMMITTED_RU, L2_ATS_RU, L2_AVAILABLE_RU, L2PATH,
							L2_M1AMT, L2_M2AMT, L2_M3AMT, L2_M4AMT, L2_M5AMT, L2_M6AMT, L2_M7AMT, L2_M8AMT, L2_M9AMT, L2_M10AMT, L2_M11AMT, L2_M12AMT, 
							L2_Q1AMT, L2_Q2AMT, L2_Q3AMT, L2_Q4AMT,
							L3ID, L3NAME, L3STATUS, L3NUMBER, L3_COMMITTED_RU, L3_ATS_RU, L3_AVAILABLE_RU, L3PATH,
							L3_M1AMT, L3_M2AMT, L3_M3AMT, L3_M4AMT, L3_M5AMT, L3_M6AMT, L3_M7AMT, L3_M8AMT, L3_M9AMT, L3_M10AMT, L3_M11AMT, L3_M12AMT, 
							L3_Q1AMT, L3_Q2AMT, L3_Q3AMT, L3_Q4AMT,
							L4ID, L4NAME, L4STATUS, L4NUMBER, L4_COMMITTED_RU, L4_ATS_RU, L4_AVAILABLE_RU, L4PATH,
							L4_M1AMT, L4_M2AMT, L4_M3AMT, L4_M4AMT, L4_M5AMT, L4_M6AMT, L4_M7AMT, L4_M8AMT, L4_M9AMT, L4_M10AMT, L4_M11AMT, L4_M12AMT, 
							L4_Q1AMT, L4_Q2AMT,L4_Q3AMT, L4_Q4AMT,
							L5ID, L5NAME, L5STATUS, L5NUMBER, L5_COMMITTED_RU, L5_ATS_RU, L5_AVAILABLE_RU, L5PATH,
							L5_M1AMT, L5_M2AMT, L5_M3AMT, L5_M4AMT, L5_M5AMT, L5_M6AMT, L5_M7AMT, L5_M8AMT, L5_M9AMT, L5_M10AMT, L5_M11AMT, L5_M12AMT, 
							L5_Q1AMT, L5_Q2AMT, L5_Q3AMT, L5_Q4AMT, GETDATE() AS UPDATEDON
							FROM  #PRD_TEMP_RPT_ACTIVITY_REPORTS   '


				DECLARE @V1_1_PER NVARCHAR(4000)
				SELECT @V1_1_PER =   N' UNION  SELECT TOP 1 
				NULL AS PLANID, NULL AS TITLE, NULL AS STATUS, NULL AS BUSINESSUNITID, NULL AS BUNAME, NULL AS PLAN_COMMITTED_RU, NULL AS PLAN_ATS_RU, NULL AS PLAN_AVAILABLE_RU, 
				NULL AS PLAN_M1AMT, NULL AS PLAN_M2AMT, NULL AS PLAN_M3AMT, NULL AS PLAN_M4AMT, NULL AS PLAN_M5AMT, NULL AS PLAN_M6AMT, NULL AS PLAN_M7AMT, NULL AS PLAN_M8AMT, NULL AS PLAN_M9AMT, NULL AS PLAN_M10AMT, NULL AS PLAN_M11AMT, NULL AS PLAN_M12AMT, NULL AS PLAN_Q1AMT, NULL AS PLAN_Q2AMT, NULL AS PLAN_Q3AMT, NULL AS PLAN_Q4AMT,
				NULL AS L1ID, NULL AS L1NAME, NULL AS L1STATUS, NULL AS L1NUMBER, NULL AS L1_COMMITTED_RU, NULL AS L1_ATS_RU, NULL AS L1_AVAILABLE_RU, NULL AS L1PATH,
				NULL AS L1_M1AMT, NULL AS L1_M2AMT, NULL AS L1_M3AMT, NULL AS L1_M4AMT, NULL AS L1_M5AMT, NULL AS L1_M6AMT, NULL AS L1_M7AMT, NULL AS L1_M8AMT, NULL AS L1_M9AMT, NULL AS L1_M10AMT, NULL AS L1_M11AMT, NULL AS L1_M12AMT, NULL AS L1_Q1AMT, NULL AS L1_Q2AMT, NULL AS L1_Q3AMT, NULL AS L1_Q4AMT,
				NULL AS L2ID, NULL AS L2NAME, NULL AS L2STATUS, NULL AS L2NUMBER, NULL AS L2_COMMITTED_RU, NULL AS L2_ATS_RU, NULL AS L2_AVAILABLE_RU, NULL AS L2PATH,
				NULL AS L2_M1AMT, NULL AS L2_M2AMT, NULL AS L2_M3AMT, NULL AS L2_M4AMT, NULL AS L2_M5AMT, NULL AS L2_M6AMT, NULL AS L2_M7AMT, NULL AS L2_M8AMT, NULL AS L2_M9AMT, NULL AS L2_M10AMT, NULL AS L2_M11AMT, NULL AS L2_M12AMT, NULL AS L2_Q1AMT, NULL AS L2_Q2AMT, NULL AS L2_Q3AMT, NULL AS L2_Q4AMT,
				NULL AS L3ID, NULL AS L3NAME, NULL AS L3STATUS, NULL AS L3NUMBER, NULL AS L3_COMMITTED_RU, NULL AS L3_ATS_RU, NULL AS L3_AVAILABLE_RU, NULL AS L3PATH,
				NULL AS L3_M1AMT, NULL AS L3_M2AMT, NULL AS L3_M3AMT, NULL AS L3_M4AMT, NULL AS L3_M5AMT, NULL AS L3_M6AMT, NULL AS L3_M7AMT, NULL AS L3_M8AMT, NULL AS L3_M9AMT, NULL AS L3_M10AMT, NULL AS L3_M11AMT, NULL AS L3_M12AMT, NULL AS L3_Q1AMT, NULL AS L3_Q2AMT, NULL AS L3_Q3AMT, NULL AS L3_Q4AMT,
				NULL AS L4ID, NULL AS L4NAME, NULL AS L4STATUS, NULL AS L4NUMBER, NULL AS L4_COMMITTED_RU, NULL AS L4_ATS_RU, NULL AS L4_AVAILABLE_RU, NULL AS L4PATH,
				NULL AS L4_M1AMT, NULL AS L4_M2AMT, NULL AS L4_M3AMT, NULL AS L4_M4AMT, NULL AS L4_M5AMT, NULL AS L4_M6AMT, NULL AS L4_M7AMT, NULL AS L4_M8AMT, NULL AS L4_M9AMT, NULL AS L4_M10AMT, NULL AS L4_M11AMT, NULL AS L4_M12AMT, NULL AS L4_Q1AMT, NULL AS L4_Q2AMT, NULL AS L4_Q3AMT, NULL AS L4_Q4AMT,
				NULL AS L5ID, NULL AS L5NAME, NULL AS L5STATUS, NULL AS L5NUMBER, NULL AS L5_COMMITTED_RU, NULL AS L5_ATS_RU, NULL AS L5_AVAILABLE_RU, NULL AS L5PATH,
				NULL AS L5_M1AMT, NULL AS L5_M2AMT, NULL AS L5_M3AMT, NULL AS L5_M4AMT, NULL AS L5_M5AMT, NULL AS L5_M6AMT, NULL AS L5_M7AMT, NULL AS L5_M8AMT, NULL AS L5_M9AMT, NULL AS L5_M10AMT, NULL AS L5_M11AMT, NULL AS L5_M12AMT, NULL AS L5_Q1AMT, NULL AS L5_Q2AMT, NULL AS L5_Q3AMT, NULL AS L5_Q4AMT, UPDATEDON
				FROM  RPT_ACTIVITY_REPORTS  '

				DECLARE @UNION1_PER NVARCHAR(4000)
				SELECT @UNION1_PER =   N' ORDER BY BUNAME, TITLE, L1NAME, L2NAME, L3NAME, L4NAME, L5NAME ASC  '

				DECLARE @V2_PER NVARCHAR(MAX)
				SELECT @V2_PER =   N'  UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET PLAN_M1AMT = M1AMT,PLAN_M2AMT = M2AMT,PLAN_M3AMT = M3AMT,PLAN_M4AMT = M4AMT,PLAN_M5AMT = M5AMT,PLAN_M6AMT = M6AMT,
							PLAN_M7AMT = M7AMT,PLAN_M8AMT = M8AMT,PLAN_M9AMT = M9AMT,PLAN_M10AMT = M10AMT,PLAN_M11AMT = M11AMT,PLAN_M12AMT = M12AMT,
							PLAN_Q1AMT = Q1AMT,PLAN_Q2AMT = Q2AMT,PLAN_Q3AMT = Q3AMT,PLAN_Q4AMT = Q4AMT
							FROM #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON PLANID = ENTITYID  
							
							UPDATE #PRD_TEMP_RPT_ACTIVITY_REPORTS
							SET L1_M1AMT = M1AMT,L1_M2AMT = M2AMT,L1_M3AMT = M3AMT,L1_M4AMT = M4AMT,L1_M5AMT = M5AMT,L1_M6AMT = M6AMT,L1_M7AMT = M7AMT,
							L1_M8AMT = M8AMT,L1_M9AMT = M9AMT,L1_M10AMT = M10AMT,L1_M11AMT = M11AMT,L1_M12AMT = M12AMT,
							L1_Q1AMT = Q1AMT,L1_Q2AMT = Q2AMT,L1_Q3AMT = Q3AMT,L1_Q4AMT = Q4AMT
							FROM  #PRD_TEMP_RPT_ACTIVITY_REPORTS INNER JOIN RPT_SPENDS ON L1ID = ENTITYID
							
							SELECT DISTINCT 
							PLANID, TITLE, STATUS, BUSINESSUNITID, BUNAME, PLAN_COMMITTED_RU, PLAN_ATS_RU, PLAN_AVAILABLE_RU, 
							PLAN_M1AMT, PLAN_M2AMT, PLAN_M3AMT, PLAN_M4AMT, PLAN_M5AMT, PLAN_M6AMT, PLAN_M7AMT, PLAN_M8AMT, PLAN_M9AMT, PLAN_M10AMT, PLAN_M11AMT,PLAN_M12AMT, PLAN_Q1AMT, PLAN_Q2AMT, PLAN_Q3AMT, PLAN_Q4AMT,
							L1ID, L1NAME, L1STATUS, L1_COMMITTED_RU, L1_ATS_RU, L1_AVAILABLE_RU, L1PATH,
							L1_M1AMT, L1_M2AMT, L1_M3AMT, L1_M4AMT, L1_M5AMT, L1_M6AMT, L1_M7AMT, L1_M8AMT, L1_M9AMT, L1_M10AMT, L1_M11AMT, L1_M12AMT, 
							L1_Q1AMT, L1_Q2AMT, L1_Q3AMT, L1_Q4AMT, GETDATE() AS UPDATEDON
							FROM #PRD_TEMP_RPT_ACTIVITY_REPORTS     '


				DECLARE @V2_2_PER NVARCHAR(4000)
				SELECT @V2_2_PER =   N' UNION  SELECT TOP 1  
				NULL AS PLANID, NULL AS TITLE, NULL AS STATUS, NULL AS BUSINESSUNITID, NULL AS BUNAME, NULL AS PLAN_COMMITTED_RU, NULL AS PLAN_ATS_RU, NULL AS PLAN_AVAILABLE_RU, 
				NULL AS PLAN_M1AMT, NULL AS PLAN_M2AMT, NULL AS PLAN_M3AMT, NULL AS PLAN_M4AMT, NULL AS PLAN_M5AMT, NULL AS PLAN_M6AMT, NULL AS PLAN_M7AMT, NULL AS PLAN_M8AMT, NULL AS PLAN_M9AMT, NULL AS PLAN_M10AMT, NULL AS PLAN_M11AMT, NULL AS PLAN_M12AMT, NULL AS PLAN_Q1AMT, NULL AS PLAN_Q2AMT, NULL AS PLAN_Q3AMT, NULL AS PLAN_Q4AMT,
				NULL AS L1ID, NULL AS L1NAME, NULL AS L1STATUS, NULL AS L1_COMMITTED_RU, NULL AS L1_ATS_RU, NULL AS L1_AVAILABLE_RU, NULL AS L1PATH,
				NULL AS L1_M1AMT, NULL AS L1_M2AMT, NULL AS L1_M3AMT, NULL AS L1_M4AMT, NULL AS L1_M5AMT, NULL AS L1_M6AMT, NULL AS L1_M7AMT, NULL AS L1_M8AMT, NULL AS L1_M9AMT, NULL AS L1_M10AMT, NULL AS L1_M11AMT, NULL AS L1_M12AMT, NULL AS L1_Q1AMT, NULL AS L1_Q2AMT, NULL AS L1_Q3AMT, NULL AS L1_Q4AMT, UPDATEDON
				FROM  RPT_ACTIVITY_REPORTS  '

				DECLARE @UNION2_PER NVARCHAR(4000)
				SELECT @UNION2_PER =   N' ORDER BY BUNAME, TITLE, L1NAME ASC '

				IF(@ISACTUALSREPORT = 1)
				BEGIN
					set @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) + @V_PER + @V1_PER + @V1_1_PER + @UNION1_PER				
					EXEC DBO.SP_EXECUTESQL @final_query
				END
				ELSE IF(@ISACTUALSREPORT = 0)
					BEGIN
						set @final_query = Cast(Replicate(' ', 50000) As nvarchar(max)) + @V_PER + @V2_PER + @V2_2_PER + @UNION2_PER
						EXEC DBO.SP_EXECUTESQL @final_query
					END
		END
	END
END
GO